﻿B4A=true
Group=Activities_E_Servizi
ModulesStructureVersion=1
Type=Activity
Version=9.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	'========================================
	' definizione oggetti e variabili di tabella
	'=====================================
	Dim SV As ScrollView
	Dim Header As Panel
	Dim Table As Panel
	Type Ty_Attivita_RowCol (row As Int, Col As Int)

	'Dim NumberOfColumns, RowHeight, RowHeight_1, ColumnWidth, ColumnWidth_1 As Int
	Dim NumberOfColumns, RowHeight, RowHeight_1 As Int
	Dim HeaderColor, LineColor, CellColor, FontColor, HeaderFontColor As Int
	Dim  ColLineWidth, RowLineWidth As Int
	Dim  FontSize As Float
	Dim  Alignment As Int
	Dim  SelectedRow As Int
	Dim  SelectedRowColor As Int		: SelectedRowColor=Colors.LightGray
	'========================================
	' impostazione dimensioni tabella
	'=====================================
	NumberOfColumns = 3 
	Dim InfoColonne (NumberOfColumns, 2) As Int ' Colonna 1 larghezza, la 2 posizione x
	Dim PercLarghezzeColonnne (NumberOfColumns) As Float
	PercLarghezzeColonnne = Array As Float(0.38, 0.31, 0.31)
	Dim h(NumberOfColumns) As String
	h = Array As String ("Tipo attività", "Inizio", "Fine")
	Dim row(NumberOfColumns) As String

	'Table settings
	HeaderColor = Colors.Gray
	ColLineWidth = 1dip
	RowLineWidth = 1dip
	RowHeight_1 = 60dip
	RowHeight=RowHeight_1+RowLineWidth
	LineColor = Colors.Black
	CellColor = Colors.White
	FontColor = Colors.Black
	HeaderFontColor = Colors.White
	FontSize = 14
	Alignment = Gravity.CENTER 'change to Gravity.LEFT or Gravity.RIGHT for other alignments.
	'========================================
	' impostazione dimensioni tabella
	'=====================================

	Private btnAvvia As Button
	Private btnConcludi As Button
	
	Dim l_idTipoAttivitaSelezionata As Int
	Dim l_idAttivitaCorrente As Int = 0
	
	Private lsvTipiAttivita As ListView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("Attivita")
	
	SV.Initialize(0)
'	SV.Color=Colors.Transparent
	SV.Panel.Color=Colors.Black
	Table = SV.Panel
	Table.Color = LineColor
	Activity.AddView(SV, 5%x, 10%y, 90%x, 80%y)
	
	For i = 0 To NumberOfColumns -1
		' qui calcolo la larghezza di ogni colonna
		InfoColonne(i, 0) = SV.Width * PercLarghezzeColonnne(i)
		
		' qui imposto la posizione di partenza della label di ogni colonna
		If i = 0 Then
			InfoColonne(0, 1) = 0 ' la prima label parte da sinistra
		Else
			InfoColonne(i, 1) = InfoColonne(i-1, 1) +  InfoColonne(i-1, 0)
		End If
		' le successive partono dalla partenza della precedente + la sua larghezza
	Next
	SelectedRow = -1
End Sub

Sub Activity_Resume
	PopolaAttivita (1,1)
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub PopolaAttivita (p_idTurno As Int, p_idUtente As Int)

	SvuotaScrollList
	SetHeader(h)
	l_idAttivitaCorrente = 0
'	If Not(Starter.a_ClsAttivita.LocalLeggi(p_idTurno, p_idUtente)) Then
'		ToastMessageShow ("errore nella lettura dei dati d attività da locale", True)
'		Return
'	End If
'	l_ListaAttivita = Starter.a_ClsAttivita.c_Lista
'	For Each l_Attivita As Ty_Attivita In l_ListaAttivita
'		If l_Attivita.DataOraFine = 0 Then
'			l_idAttivitaCorrente = l_Attivita.id
'		End If
	DateTime.TimeFormat = "HH:mm"
	row (0) = "Test1"
	row (1) = DateTime.Now
	row (2) = DateTime.Now
	AddRow(row)

	row (0) = "Test2"
	row (1) = DateTime.Now
	row (2) = DateTime.Now

	row (0) = "Test3"
	row (1) = DateTime.Now
	row (2) = DateTime.Now
	AddRow(row)



'	Next

	InizializzaListTipoAttivita(p_idTurno, p_idUtente)
	
	
	If l_idAttivitaCorrente = 0 Then
		btnAvvia.Enabled = True
		btnConcludi.Enabled = False
	Else
		btnAvvia.Enabled = False
		btnConcludi.Enabled = True
	End If
	lsvTipiAttivita.Visible = True
	lsvTipiAttivita.RequestFocus
	
	
End Sub
Sub SvuotaScrollList
	For i = Table.NumberOfViews -1 To 0 Step -1
		Table.RemoveViewAt(i)
	Next
	Table.Height = 0
	SelectedRow = -1
End Sub
Sub SetHeader(Values() As String)
	If Header.IsInitialized Then Return 'should only be called once
	Header.Initialize("")
	For i = 0 To NumberOfColumns - 1
		Dim l As Label
		l.Initialize("header")
		l.Text = Values(i)
		l.Gravity = Gravity.CENTER
		l.TextSize = FontSize
		l.Color = HeaderColor
		l.TextColor = HeaderFontColor
		l.Tag = i
		'Header.AddView(l, ColumnWidth * i, 0, ColumnWidth_1, RowHeight_1)
		Header.AddView(l, InfoColonne(i, 1) , 0, InfoColonne(i, 0) - ColLineWidth, RowHeight_1)
	Next
	Activity.AddView(Header, SV.Left, SV.Top - RowHeight, SV.Width, RowHeight)
End Sub
Sub AddRow(Values() As String)
	If Values.Length <> NumberOfColumns Then
		Log("Wrong number of values.")
		Return
	End If
	Dim lastRow As Int
	lastRow = NumberOfRows
	For i = 0 To NumberOfColumns - 1
		Dim l As Label
		l.Initialize("cell")
		l.Text = Values(i)
		l.Gravity = Alignment
		l.TextSize = FontSize
		l.TextColor = FontColor
		l.Color=Colors.White
		Dim rc As Ty_Attivita_RowCol
		rc.Initialize
		rc.Col = i
		rc.Row = lastRow
		l.Tag = rc
'		Table.AddView(l, ColumnWidth * i, RowHeight * lastRow, ColumnWidth_1, RowHeight_1)
		Table.AddView(l, InfoColonne(i, 1) , RowHeight * lastRow, InfoColonne(i, 0) - ColLineWidth  , RowHeight_1)
	Next
	Table.Height = NumberOfRows * RowHeight
End Sub
Sub NumberOfRows As Int
	Return Table.NumberOfViews / NumberOfColumns
End Sub
Sub Cell_Click
	Dim rc As Ty_Attivita_RowCol
	Dim l As Label
	l = Sender
	rc = l.Tag
	SelectRow(rc.Row)
	Activity.Title = "Cell clicked: (" & rc.Row & ", " & rc.Col & ")"
End Sub

Sub Header_Click
	Dim l As Label
	Dim col As Int
	l = Sender
	col = l.Tag
	Activity.Title = "Header clicked: " & col
End Sub

Sub SelectRow(riga As Int)
	'remove the color of previously selected row
	If SelectedRow > -1 Then
		For col = 0 To NumberOfColumns - 1
			GetView(SelectedRow, col).Color = CellColor
		Next
	End If
	SelectedRow = riga
	For col = 0 To NumberOfColumns - 1
		GetView(riga, col).Color = SelectedRowColor
	Next
End Sub
Sub GetView(riga As Int, Col As Int) As Label
	Dim l As Label
	l = Table.GetView(riga * NumberOfColumns + Col)
	Return l
End Sub

Sub InizializzaListTipoAttivita (p_idTurno As Int, p_idUtente As Int)
	'lsvTipiAttivita.Clear
	
'	If Not(Starter.a_ClsRuoliTipiAttivita.LocalLeggiTipiAttivitaPerTurnoUtente(p_idTurno, p_idUtente)) Then
'		ToastMessageShow ("errore nella lettura dei dati di ruolo  attività da locale", True)
'		Return
'	End If
'	For Each l_Attivita As Ty_TipoAttivita In Starter.a_ClsRuoliTipiAttivita.c_ListaAtt
		lsvTipiAttivita.AddSingleLine("job 1")
		lsvTipiAttivita.AddSingleLine("Job 2")
		lsvTipiAttivita.AddSingleLine("job 3")
'	Next
	

End Sub


Sub btnConcludi_Click
	
End Sub

Sub btnAvvia_Click
	Dim l_Att As Ty_Attivita
	l_Att.idTipoAttivita = l_idTipoAttivitaSelezionata
	l_Att.idTurno = Starter.a_IdTurnoSelezionato
	l_Att.idUtente = Starter.a_idUtenteLoggato
	l_Att.DataOraInizio = DateTime.Now
	l_Att.DataOraInizioDaInviare = 1
	l_Att.DataOraFine = 0
	l_Att.DataOraFineDaInviare = 0
	
	PopolaAttivita(Starter.a_IdTurnoSelezionato, Starter.a_idUtenteLoggato)
End Sub

Sub lsvTipiAttivita_ItemClick (Position As Int, Value As Ty_TipoAttivita)
	l_idTipoAttivitaSelezionata = Value.id
End Sub